from PyQt5 import QtGui
from PyQt5.QtWidgets import QApplication, QMainWindow, QGraphicsScene, QGraphicsView, QGraphicsItem, QGraphicsPixmapItem, QGraphicsTextItem, QGraphicsEffect, QGraphicsDropShadowEffect, QGraphicsBlurEffect
from PyQt5.QtGui import QPixmap, QPainter, QFont
from PyQt5.Qt import Qt
 
import sys
 
class Window(QMainWindow):
    def __init__(self):
        super().__init__()
 
        self.title = "Эффекты"
        self.top = 200
        self.left = 500
        self.width = 400
        self.height = 400

        # Флаг для выбора эффекта
        self.flag = True
        
        self.setWindowTitle(self.title)
        # Задание местоположения и размера окна
        self.setGeometry(self.left, self.top, self.width, self.height)
        # Создание графической сцены
        self.scene = QGraphicsScene()
        # Создание инструмента для отрисовки графической сцены
        self.graphicView = QGraphicsView(self.scene, self)
        # Задание местоположения и размера графической сцены
        self.graphicView.setGeometry(0, 0, self.width, self.height)

    def keyPressEvent(self, event):
        # Обработчик нажатия клавиш
        self.flag = not self.flag
        if self.flag == True:
            # Задание эффекта тени
            shadow = QGraphicsDropShadowEffect()
            shadow.setBlurRadius(10)
            shadow.setXOffset(5)
            shadow.setYOffset(5)
            # Добавление эффекта к объекту
            self.image.setGraphicsEffect(shadow)
        else:
            # Размытие и его параметры
            blur = QGraphicsBlurEffect()
            blur.setBlurRadius(3)
            # Добавление эффекта к объекту
            self.image.setGraphicsEffect(blur)
        event.accept() # Завершение обработки события
        
    def plot(self):
        # Создание объекта QPixmap
        self.picture = QPixmap('IMG2.jpg')
        # Создание "пустого" объекта QGraphicsPixmapItem
        self.image = QGraphicsPixmapItem()
        # Задание изображения в объект QGraphicsPixmapItem
        self.image.setPixmap(self.picture)
        # Позиция объекта QGraphicsPixmapItem
        self.image.setOffset(0, 0)
        # Задание эффекта тени
        shadow = QGraphicsDropShadowEffect()
        shadow.setBlurRadius(10)
        shadow.setXOffset(5)
        shadow.setYOffset(5)
        # Добавление эффекта к объекту
        self.image.setGraphicsEffect(shadow)
        # Добавление объекта QGraphicsPixmapItem на сцену
        self.scene.addItem(self.image)


App = QApplication(sys.argv)
window = Window()
window.show() # Демонстрация окна
window.plot() # Построение и перерисовка окна

sys.exit(App.exec())
